<#ibizinclude>
../@MACRO/LAYOUTPANEL_VIEW.template.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/VIEW_HEADER-BASE.vue.ftl
</#ibizinclude>

<#assign mounted_block>
        this.viewState.next({ tag: 'appmenu', action: 'load', data: {} });
        this.$viewTool.setIndexParameters([{ pathName: '${view.getCodeName()?lower_case}', parameterName: '${view.getCodeName()?lower_case}' }]);
        this.$viewTool.setIndexViewParam(this.context);
        this.draggable();
        <#--  let loader:any = document.getElementById('app-loader');
        loader.parentNode.removeChild(loader);  -->
</#assign>

<#ibizinclude>
../@MACRO/VIEW_CONTENT-BASE.vue.ftl
</#ibizinclude>

    /**
     * 菜单位置
     *
     * @public
     * @type {string}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public mode: string ='<#if view.getMainMenuAlign()=="TOP">horizontal</#if><#if view.getMainMenuAlign()=="LEFT" || view.getMainMenuAlign() =="">vertical</#if>';

    /**
     * 导航模式(route:面包屑模式、tab:分页导航模式)
     *
     * @type {string}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    @Provide()
    public navModel:string = "<#if view.getViewStyle() == "STYLE2">route<#else>tab</#if>";

    /**
     * 抽屉状态
     *
     * @type {boolean}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public contextMenuDragVisiable: boolean = false;

    /**
     * 是否支持应用切换
     *
     * @type {boolean}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public isEnableAppSwitch: boolean = <#if view.isEnableAppSwitch?? && view.isEnableAppSwitch()??>${view.isEnableAppSwitch()?c}<#else>false</#if>;

    <#if view.getViewStyle() != "STYLE2">
    /**
     * 初始化之前
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public beforeCreate(){
        let navDataService = NavDataService.getInstance(this.$store)
        navDataService.removeAllNavData();
    }
    </#if>

    /**
     * 当前主题
     *
     * @readonly
     * @memberof ${srfclassname('${view.name}')}Base
     */
    get selectTheme() {
        if (this.$router.app.$store.state.selectTheme) {
            return this.$router.app.$store.state.selectTheme;
        } else if (localStorage.getItem('theme-class')) {
            return localStorage.getItem('theme-class');
        } else {
            return 'app-default-theme';
        }
    }

    /**
     * 当前字体
     *
     * @readonly
     * @memberof ${srfclassname('${view.name}')}Base
     */
    get selectFont() {
        if (this.$router.app.$store.state.selectFont) {
            return this.$router.app.$store.state.selectFont;
        } else if (localStorage.getItem('font-family')) {
            return localStorage.getItem('font-family');
        } else {
            return 'Microsoft YaHei';
        }
    }

    /**
     * 菜单收缩变化
     *
     * @type {boolean}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public collapseChange: boolean = false;

    /**
     * 菜单收缩点击
     *
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public handleClick(): void {
        this.collapseChange = !this.collapseChange;
    }

    /**
     * 默认打开的视图
     *
     * @type {*}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public defPSAppView: any = {
        <#if view.getDefPSAppView()??>
        <#assign dataview = view.getDefPSAppView()>
        codename: '${dataview.getCodeName()?lower_case}',
        viewtitle: '${dataview.getTitle()}',
        openmode: '${dataview.getOpenMode()}',
        width: ${dataview.getWidth()?c},
        height: ${dataview.getHeight()?c},
        deResParameters: [],
        <#--  BEGIN：是否应用实体视图  -->
        <#if dataview.isPSDEView()>
        <#assign appDataEntity = dataview.getPSAppDataEntity()/>
        routepath: '/${view.getCodeName()?lower_case}/:${view.getCodeName()?lower_case}?/${srfpluralize(appDataEntity.codeName)?lower_case}/:${appDataEntity.getCodeName()?lower_case}?/${dataview.getPSDEViewCodeName()?lower_case}/:${dataview.getPSDEViewCodeName()?lower_case}?',
        parameters: [
            { pathName: '${srfpluralize(appDataEntity.codeName)?lower_case}', parameterName: '${appDataEntity.getCodeName()?lower_case}' },
            { pathName: '${dataview.getPSDEViewCodeName()?lower_case}', parameterName: '${dataview.getPSDEViewCodeName()?lower_case}' },
        ],
        <#else>
        routepath: '/${view.getCodeName()?lower_case}/:${view.getCodeName()?lower_case}?/${dataview.getCodeName()?lower_case}/:${dataview.getCodeName()?lower_case}?',
        parameters: [
            { pathName: '${dataview.getCodeName()?lower_case}', parameterName: '${dataview.getCodeName()?lower_case}' },
        ],
        </#if>
        <#--  END：是否应用实体视图  -->
        </#if>
    };

    /**
     * 应用起始页面
     *
     * @type {boolean}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public isDefaultPage: boolean = ${view.isDefaultPage()?c};

    /**
     * 空白视图模式
     *
     * @type {boolean}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public isBlankMode:boolean = ${view.isBlankMode()?c};

    /**
     * 获取样式
     *
     * @readonly
     * @type {string[]}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    get themeClasses(): string[] {
        return [
            Object.is(this.selectTheme, 'app_theme_blue') ? 'app_theme_blue' : '',
            Object.is(this.selectTheme, 'app-default-theme') ? 'app-default-theme' : '',
            Object.is(this.selectTheme, 'app_theme_darkblue') ? 'app_theme_darkblue' : '',
        ];
    }

    /**
     * 主题字体
     *
     * @readonly
     * @type {*}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    get themeStyle(): any {
        return {
            'height': '100vh',
            'font-family': this.selectFont,
        }
    }

    /**
     * 获取路由列表
     *
     * @readonly
     * @type {any[]}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    get getRouterList(): any[] {
        return this.$store.state.historyPathList;
    }

    /**
     * 获取路由键值
     *
     * @readonly
     * @type {string}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    get getRouterViewKey(): string {
        return this.$route.fullPath;
    }

    /**
     * 鼠标拖动点击事件
     *
     * @param {*} val
     * @returns {*}
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public draggable(){
        let resizeLine:any = document.getElementById("move_axis");
        let sideBar :any= resizeLine.previousElementSibling;
        let content :any= resizeLine.nextElementSibling;
        let container :any= resizeLine.parentElement;
        let leftWidth :number = parseInt(sideBar.style.width);
        resizeLine.onmousedown = (e:any) =>{
            let startX = e.clientX;
            resizeLine.left = resizeLine.offsetLeft;
            this.dragging(resizeLine,startX,container,sideBar,content,leftWidth);
            this.dragEnd(resizeLine);
            resizeLine.setCapture && resizeLine.setCapture();
            return false;
        }
    }

    /**
     * 鼠标拖动事件
     *
     * @param {*} resizeLine   拖动滑块
     * @param {*} startX       拖动起始位置
     * @param {*} container    父节点
     * @param {*} sideBar      侧边栏
     * @param {*} content      右侧内容区域
     * @param {*} leftWidth    侧边栏宽度
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public dragging(resizeLine:any,startX:any,container:any,sideBar:any,content:any,leftWidth:any) {
        document.onmousemove =  (e:any) =>{
            let endX = e.clientX;
            let moveDistance = resizeLine.left + (endX - startX);
            let maxT = container.clientWidth - resizeLine.offsetWidth;
            if(moveDistance < 150) moveDistance = 150;
            if(moveDistance > maxT - 150) moveDistance = maxT - 150;
            resizeLine.style.left = moveDistance;
            sideBar.style.width = moveDistance + 'px';
            content.style.width = (container.clientWidth - moveDistance - 5) + 'px';
            if(moveDistance > 500) {
                sideBar.style.width = 500 + 'px'
            }
            let left_Width :number = parseInt(sideBar.style.width);
            resizeLine.style.left = left_Width - 5 + 'px';
            if(left_Width < left_Width) {
                sideBar.style.left = leftWidth  - 5 + 'px'
            }
        }
    }

    /**
     * 鼠标拖动结束事件
     *
     * @param {*} resizeLine
     * @memberof ${srfclassname('${view.name}')}Base
     */
    public dragEnd(resizeLine:any) {
        document.onmouseup = (evt) =>{
            document.onmousemove = null;
            document.onmouseup = null;
            resizeLine.releaseCapture && resizeLine.releaseCapture();
        }
    }
}

<#ibizinclude>
../@MACRO/VIEW_BOTTOM-BASE.vue.ftl
</#ibizinclude>

<#ibizinclude>
../@MACRO/VIEW-BASE.style.ftl
</#ibizinclude>